import { ImageRequireSource, ImageURISource } from 'react-native-macos';
export declare type SVGKPreloadOptions = {
    key?: string;
    data?: string;
    source?: ImageURISource | ImageRequireSource;
};
export declare function useSvg(options: SVGKPreloadOptions): string | undefined;
/** Preload an `<svg>` into memory. Returns the cache key. */
export declare function preloadSvg(options: SVGKPreloadOptions): string;
/**
 * Reclaim memory taken by cached `<svg>` data.
 *
 * Does not affect views which are using the cached data.
 */
export declare function unloadSvg(cacheKey: string): void;
