import * as React from 'react';
import { ImageURISource, ImageRequireSource, NativeSyntheticEvent, ShadowStyleIOS, FlexStyle, StyleProp, EventProps, NativeMethodsMixin, PointPropType } from 'react-native-macos';
import { SVGKPreloadOptions } from './SVGKCache';
export declare type SVGErrorEvent = NativeSyntheticEvent<{
    error: string;
}>;
export declare type SVGLoadEvent = NativeSyntheticEvent<{
    source: {
        height: number;
        width: number;
        url: string;
    };
}>;
interface Style extends FlexStyle, ShadowStyleIOS {
    opacity?: number;
    backfaceVisibility?: boolean;
    shouldRasterizeIOS?: boolean;
}
interface Props extends EventProps {
    data?: string;
    source?: ImageURISource | ImageRequireSource;
    cacheKey?: string;
    tintColor?: string;
    anchorPoint?: PointPropType;
    style?: StyleProp<Style>;
    onLoadStart?: () => void;
    onError?: (event: SVGErrorEvent) => void;
    onLoad?: (event: SVGLoadEvent) => void;
    onLoadEnd?: () => void;
}
export declare type SVGKView = React.ForwardRefExoticComponent<Props & React.RefAttributes<NativeMethodsMixin>> & {
    preload: (options: SVGKPreloadOptions & {
        style?: Style;
        tintColor?: string;
        anchorPoint?: PointPropType;
    }) => React.SFC<Props>;
};
export declare const SVGKView: SVGKView;
export {};
