"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_macos_1 = require("react-native-macos");
var SVGKCache_1 = require("./SVGKCache");
var RNSVGKView = react_native_macos_1.requireNativeComponent('RNSVGKView');
exports.SVGKView = React.forwardRef(function (props, ref) { return (<RNSVGKView onError={console.error} {...props} source={props.source && react_native_macos_1.Image.resolveAssetSource(props.source)} style={computeStyle(props)} ref={ref}/>); });
exports.SVGKView.displayName = 'SVGKView';
/**
 * Create a component that renders the given <svg> source and preloads it.
 */
exports.SVGKView.preload = function (options) {
    var cacheKey = SVGKCache_1.preloadSvg(options);
    return function (props) { return (<exports.SVGKView anchorPoint={options.anchorPoint} tintColor={options.tintColor} {...props} style={[props.style, options.style]} cacheKey={cacheKey}/>); };
};
function computeStyle(props) {
    var style = react_native_macos_1.StyleSheet.flatten(props.style) || {};
    if (style.width == null && style.height == null) {
        if (style.flex == null) {
            style.flex = 1;
        }
    }
    return style;
}
//# sourceMappingURL=SVGKView.js.map